#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "gram.y"
/* $Header: /local/src/CVS/nickle/gram.y,v 1.127 2004/02/27 03:50:16 keithp Exp $ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 2 reduce/reduce and 4 shift/reduce conflicts:
 * 
 * reduce/reduce conflict on:
 *
 *	    *int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  reduce/reduce conflict on:
 *
 *	   &int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict on NL:
 *
 *	    opt_nl : .
 *
 *	This says that you can have multiple NLs in a row
 *	and the grammar can't tell which opt_nl is reduced.
 *	No big deal.
 *
 *  shift/reduce conflict on CATCH:
 *
 *	That's because CATCH blocks are optional and chained.
 *	Shifting binds the CATCH to the nearest enclosing TRY,
 *	just like ELSE
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers
 *	(of course, you can always enclose an assignment in parens)
 *
 *  shift/reduce conflict on ELSE
 *
 *	Need we say more?
 */
int ignorenl;
int notCommand;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 80 "gram.y"
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#line 110 "gram.c"
#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define NL 265
#define SEMI 266
#define MOD 267
#define OC 268
#define CC 269
#define DOLLAR 270
#define DOTS 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FILET 282
#define MUTEX 283
#define SEMAPHORE 284
#define CONTINUATION 285
#define THREAD 286
#define VOID 287
#define BOOL 288
#define FUNCTION 289
#define FUNC 290
#define EXCEPTION 291
#define RAISE 292
#define TYPEDEF 293
#define IMPORT 294
#define NEW 295
#define ANONINIT 296
#define NAMESPACE 297
#define PUBLIC 298
#define PROTECTED 299
#define EXTEND 300
#define IF 301
#define ELSE 302
#define WHILE 303
#define DO 304
#define FOR 305
#define SWITCH 306
#define BREAK 307
#define CONTINUE 308
#define RETURNTOK 309
#define FORK 310
#define CASE 311
#define DEFAULT 312
#define TRY 313
#define CATCH 314
#define TWIXT 315
#define NAME 316
#define TYPENAME 317
#define NAMESPACENAME 318
#define COMMAND 319
#define NAMECOMMAND 320
#define TEN_NUM 321
#define OCTAL0_NUM 322
#define OCTAL_NUM 323
#define BINARY_NUM 324
#define HEX_NUM 325
#define TEN_FLOAT 326
#define OCTAL0_FLOAT 327
#define OCTAL_FLOAT 328
#define BINARY_FLOAT 329
#define HEX_FLOAT 330
#define CHAR_CONST 331
#define STRING_CONST 332
#define POLY_CONST 333
#define THREAD_CONST 334
#define VOIDVAL 335
#define BOOLVAL 336
#define DARROW 337
#define POUND 338
#define COMMA 339
#define ASSIGN 340
#define ASSIGNPLUS 341
#define ASSIGNMINUS 342
#define ASSIGNTIMES 343
#define ASSIGNDIVIDE 344
#define ASSIGNDIV 345
#define ASSIGNMOD 346
#define ASSIGNPOW 347
#define ASSIGNSHIFTL 348
#define ASSIGNSHIFTR 349
#define ASSIGNLXOR 350
#define ASSIGNLAND 351
#define ASSIGNLOR 352
#define QUEST 353
#define COLON 354
#define OR 355
#define AND 356
#define LOR 357
#define LXOR 358
#define LAND 359
#define EQ 360
#define NE 361
#define LT 362
#define GT 363
#define LE 364
#define GE 365
#define SHIFTL 366
#define SHIFTR 367
#define PLUS 368
#define MINUS 369
#define TIMES 370
#define DIVIDE 371
#define DIV 372
#define POW 373
#define UNIONCAST 374
#define UMINUS 375
#define BANG 376
#define FACT 377
#define LNOT 378
#define INC 379
#define DEC 380
#define STAR 381
#define AMPER 382
#define THREADID 383
#define OS 384
#define CS 385
#define DOT 386
#define ARROW 387
#define STAROS 388
#define CALL 389
#define OP 390
#define CP 391
#define POINTER 392
#define COLONCOLON 393
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   86,   86,   89,   89,   90,   91,   88,   92,
   93,   93,   94,   94,   95,   95,   87,   87,   87,   87,
   87,   87,    2,    2,    4,    4,    3,    6,    6,    6,
    5,    5,   21,   21,    1,    1,   22,   22,   52,   52,
   96,   97,    7,   98,   99,   10,   10,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,  100,   11,   11,   11,   11,
   12,   12,   13,    8,    8,  101,    9,   14,   14,   15,
   16,   16,   17,   17,   18,   19,   19,   20,   20,   31,
   31,   27,   27,   29,   29,   34,   34,   28,   28,   30,
   37,   32,   33,   33,   33,   35,   35,   35,   36,   36,
   36,   36,   36,   36,   36,   40,   40,   40,   40,   40,
   39,   39,   39,   41,   41,   41,   41,   41,   41,   38,
   38,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   42,   42,   43,   43,   45,   45,   46,
   46,   47,   47,   48,   48,   48,   48,   49,   49,   50,
   50,   51,   51,   53,   53,   54,   54,   55,   55,   58,
   56,   56,   57,   57,   59,   59,   60,   60,   61,   61,
   62,   62,   69,   69,   63,   63,   64,   64,   67,   67,
   68,   68,   65,   65,   65,   65,   65,   65,   65,   65,
   65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
   65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
   65,   65,   65,   65,   65,   65,   65,   70,   70,   70,
   70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   66,   66,   71,   71,   72,   72,   72,   72,   72,   73,
   73,   73,   74,   74,   23,   23,   24,   24,   25,   26,
   75,   75,   76,   76,   77,   77,   77,   78,   79,   79,
   80,   81,   81,   82,   83,   83,   84,   84,   85,   85,
   85,   85,
};
short yylen[] = {                                         2,
    2,    0,    1,    3,    1,    1,    0,    0,    0,    0,
    1,    0,    1,    0,    1,    0,    4,    6,    4,    6,
    6,    1,    1,    0,    3,    1,    2,    1,    1,    1,
    3,    0,    2,    1,    2,    1,    3,    2,    1,    1,
    0,    0,    3,    2,    2,    2,    0,    9,   11,    9,
   10,   13,    9,   10,    2,    2,    3,    2,    1,    1,
    3,    9,    6,    6,    7,    0,    9,    6,    5,   11,
    2,    0,    6,    1,    1,    0,    2,    1,    3,    3,
    2,    0,    4,    3,    3,    2,    0,    7,    3,    1,
    0,    3,    1,    3,    1,    1,    1,    4,    2,    1,
    1,    4,    3,    4,    4,    2,    2,    0,    5,    4,
    4,    3,    4,    3,    3,    2,    4,    4,    4,    0,
    2,    2,    2,    1,    4,    4,    4,    3,    1,    1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    3,    1,    3,    1,    4,
    0,    4,    0,    1,    1,    1,    1,    1,    0,    1,
    1,    1,    1,    3,    2,    3,    2,    2,    1,    3,
    1,    0,    3,    2,    2,    1,    1,    0,    1,    0,
    1,    2,    1,    3,    1,    0,    3,    1,    1,    0,
    3,    2,    1,    3,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    5,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    6,    8,    8,    8,
    3,    6,    2,    1,    3,    3,    4,    4,    4,    3,
    3,    6,    1,    0,    1,    1,    1,    1,    1,    1,
    2,    0,    5,    9,    2,    1,    3,    1,    1,    0,
    3,    1,    1,    1,    1,    2,    0,    4,    3,    1,
    3,    1,    1,    4,    3,    1,    3,    3,    1,    1,
    1,    2,
};
short yydefred[] = {                                      2,
    0,    9,   22,    1,    3,    0,    0,    0,    0,    0,
   60,    0,   41,    0,  154,  155,  156,  157,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
    7,    0,  160,  161,  163,    7,    7,    7,    7,    7,
    0,    0,    0,    0,    7,    7,   39,   34,    0,    0,
    0,  242,  244,  243,  245,  246,  247,  249,  248,  250,
  251,  252,  253,  254,  255,    0,    0,    0,    0,    0,
    0,    0,    0,  264,    0,  241,   59,    9,  129,    0,
    0,   41,    0,    0,    0,    0,  124,    0,    0,    0,
    0,   36,    0,    0,    0,    0,    0,    5,    6,    4,
    0,    0,    7,    0,  275,  277,  276,  278,  279,  195,
   44,  263,  273,    0,    0,    0,   41,   41,   41,   41,
   41,   55,   56,    0,    0,    0,    0,  179,    0,    0,
    0,   41,   38,    9,  185,    0,    9,    0,   23,    0,
  123,    0,    0,  122,    0,    0,    0,    0,    0,  256,
    0,    0,    0,    0,    0,   33,    0,   35,   75,   42,
   74,    0,    0,    0,    0,  182,    0,   41,    0,    0,
    0,    0,  121,    0,    0,    0,    0,    0,    0,    7,
    0,    7,    7,    7,    7,    0,    0,    7,   58,    0,
    0,    0,  240,  228,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,  239,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  201,  203,  205,    0,    0,
    0,    0,    0,    0,    0,   42,    0,    0,    0,  130,
    0,    0,    0,   41,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  100,   57,   72,    0,    0,    0,    0,
   32,   28,   30,   29,    0,    0,    0,    0,    0,    0,
  266,    0,    0,  265,   11,   19,   37,   61,    0,   78,
   77,    0,    0,    0,  171,    0,    0,  103,    0,    0,
    0,  261,  112,    0,    0,    0,    0,  165,    0,    0,
    0,  116,  123,  122,    0,    0,    0,  114,    0,    0,
    0,    0,    7,    0,  115,    0,    9,   17,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  270,  271,    0,    0,    0,  189,    0,    0,   43,
   46,    0,  125,    0,  126,    0,    0,  127,  105,    0,
    0,    0,    0,    0,    0,    0,    0,   13,    0,  187,
    0,   25,   31,    0,    0,    0,    0,    0,    0,    0,
    0,  175,  102,  177,    0,  174,  104,    0,    0,  309,
  311,  310,  107,  101,    0,    0,   76,    0,    0,    0,
  168,  164,    0,  167,  128,  110,   41,   97,    0,    0,
    0,    0,    0,  111,    0,  113,   40,   66,    0,    0,
  268,  267,    0,  192,  269,   45,    0,    0,    0,   92,
    0,    0,    0,    0,    0,    0,    0,   71,   69,    0,
   20,   21,   41,  146,   41,   41,  148,    0,   42,   79,
  173,  312,    0,    0,    0,    0,  292,    0,  300,    0,
    0,  306,    0,   98,    0,   42,  119,  117,  118,  166,
    0,    8,    0,   96,    0,    8,  109,    0,   18,    0,
  191,  150,  152,    0,   63,    0,    0,    0,    0,    0,
   41,    0,    0,    0,    0,    0,  257,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  170,  272,   42,   64,
   94,    8,   68,    0,    0,    0,   42,    0,    0,   42,
    0,    0,    0,    0,   42,  295,    0,   42,    0,   42,
  280,    0,  308,  289,  290,    0,    0,  291,  294,    0,
    0,  299,  303,  298,  301,    0,  305,  304,    0,   65,
    0,   42,    0,    0,    8,    8,   42,    0,    8,    0,
    0,   42,    0,    0,    0,  296,  260,  258,  281,  259,
    0,    0,  283,    8,    8,    8,   41,    0,   42,    0,
   42,   48,   50,    8,    0,   53,    0,    0,   80,   81,
   42,   42,    0,  287,   62,   67,   54,    0,    0,   85,
   86,    8,   51,    0,    0,   84,   73,    8,    0,  286,
   42,    0,   89,   49,   42,   83,   70,  285,    0,   90,
    0,    8,  284,    0,   52,   42,   88,
};
short yydgoto[] = {                                       1,
   76,  137,  138,  139,  140,  265,   77,  160,  161,  236,
  237,  366,  438,  281,  520,  562,  563,  552,  579,  580,
   79,   80,  611,  535,  536,  571,  246,  166,  410,  167,
  621,   81,   82,  411,  290,   83,  395,   84,  129,  173,
   86,  295,  268,   87,  269,  241,  243,   88,   89,   90,
   91,   92,  174,  300,  301,  284,  285,  397,  286,  386,
  127,  238,  134,  135,   94,   95,  346,  347,   96,  229,
  112,  110,  530,  390,  456,  457,  525,  391,  458,  459,
  460,  392,  461,  462,  539,    4,    5,    7,  100,  170,
  439,    6,  276,  369,  501,  111,  349,   97,  350,  478,
  162,
};
short yysindex[] = {                                      0,
   53,    0,    0,    0,    0, 1035, -208, -241, -125, -145,
    0,  301,    0,  301,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -133,    0,    0,    0,    0,    0,    0,    0,    0,
  -87,  -18, 1398, 2263,    0,    0,    0,    0, -160, 2263,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2263, 2263, 2263, 2263, 2263,
 2263, 2263, -122,    0, 1277,    0,    0,    0,    0,   57,
    8,    0, -115,   -8,  -99, -334,    0, 2636,  245, 2577,
   18,    0, -251, 4698,  220,  -46, 1156,    0,    0,    0,
 2636, 2636,    0,   37,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   71,  -24,   87,    0,    0,    0,    0,
    0,    0,    0,  145,   75, 2577,   44,    0,  -99,  386,
 1156,    0,    0,    0,    0, 2987,    0,   59,    0,  160,
    0,   81,   81,    0,   81,   81,   81,   81,   81,    0,
 1900,   35, -204,   38,  177,    0,   52,    0,    0,    0,
    0, -238, 2636,  138,   80,    0,  133,    0,  186,  177,
 2384,  788,    0, -334, -160, 2636, 2636, 2636,   12,    0,
  177,    0,    0,    0,    0, 2636,  177,    0,    0, 1398,
  239, 2263,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2263, 2263, 2263, 2263, 2263,
 2263, 2263, 2263, 2263, 2263, 2263, 2263, 2263, 2263, 2263,
 2263, 2263, 2263, 2263, 2263,    0,    0,    0, 2263, 2263,
  198,  201, 2263, 2263, 2263,    0, 1156,  258,   37,    0,
  256,   37,  262,    0,  188,  266,  150, 2263,  156,  157,
 1156,  163,  168,    0,    0,    0,  172,  284, 2263,  284,
    0,    0,    0,    0,  171, 2263,  -42, -193,  182, 4591,
    0,  255,    0,    0,    0,    0,    0,    0, 2263,    0,
    0,  263,    0,  181,    0, -192,  191,    0, 2021,  244,
  194,    0,    0,   49,  193,  249,  205,    0,  278,  195,
 -103,    0,    0,    0,  204,   52,  177,    0,  285, 2623,
 -133,  177,    0,  177,    0,  100,    0,    0,   51, 4646,
  517, 1140, 1261, 1885,  724, 1948, 1948,  638,  638,  638,
  638,  270,  270,   95,   95,   51,   51,   51,   51, 4698,
  215,    0,    0,  217, 4539,  218,    0, 4698,  342,    0,
    0,  351,    0,  354,    0,  240,   37,    0,    0,  238,
 1398, 1398,  332, 1398, 1398,  330, 1398,    0,  371,    0,
  380,    0,    0,  257,  277,  261,  265, 2263,  268,  389,
 2805,    0,    0,    0, 2636,    0,    0, 1525, 4698,    0,
    0,    0,    0,    0,   75, 2636,    0, -334, -334, -334,
    0,    0, 2636,    0,    0,    0,    0,    0,    0,  394,
  326,  134,  395,    0,  177,    0,    0,    0,  408, 2263,
    0,    0, 2263,    0,    0,    0, 2636, 2636, 1398,    0,
  414,  306,  307,  345,  450,  349, -133,    0,    0,  470,
    0,    0,    0,    0,    0,    0,    0, 2496,    0,    0,
    0,    0,  420, -122, 4698,  424,    0,  425,    0,  430,
  429,    0,    0,    0,  378,    0,    0,    0,    0,    0,
  383,    0,  134,    0,  504,    0,    0,  506,    0,  386,
    0,    0,    0,  384,    0, 1156, 1156, 1398, 1398,  508,
    0, 1398,  509,  511,  515,  220,    0, 2021,  469, 2021,
  516, 2021,  521, 2021,  475,  527,    0,    0,    0,    0,
    0,    0,    0, 1156,  508,  495,    0,  413,  545,    0,
  173,  194,  437, 1652,    0,    0, 2142,    0, 1779,    0,
    0, 4698,    0,    0,    0,  490, 4698,    0,    0,  566,
 4698,    0,    0,    0,    0,  420,    0,    0,  600,    0,
  598,    0,  187, 1156,    0,    0,    0, 1398,    0, 1398,
  518,    0,  173,  508, 1156,    0,    0,    0,    0,    0,
  485,  469,    0,    0,    0,    0,    0,  537,    0,  187,
    0,    0,    0,    0,  480,    0,  540, 1156,    0,    0,
    0,    0, -203,    0,    0,    0,    0,  579, 1156,    0,
    0,    0,    0, 1156, 1156,    0,    0,    0, 2021,    0,
    0,  582,    0,    0,    0,    0,    0,    0,  630,    0,
  546,    0,    0, 1156,    0,    0,    0,
};
short yyrindex[] = {                                      0,
  914,    0,    0,    0,    0,  283,    0,    0,    0,    0,
    0,    0,    0, 2690,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -222,  611,    0,    0,    0,    0, 2745,   13,
   33,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  611,  611,  611,  611,  611,
  611,  611,    0,    0,  611,    0,    0,    0,    0,    0,
 -165,    0,    0,    0,   30,  130,    0,  -79,  607,  147,
    0,    0,  641,  -63, 3054, -214,  203,    0,    0,    0,
 -257, -226,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -172,    0,    0,  617, -233,
  283,    0,    0,    0,    0, -240,    0,  247,    0,    0,
    0, 3171, 3226,    0, 3281, 3336, 3391, 3446, 3501,    0,
  611,    0, -127,    0,  654,    0, 2745,    0,    0,    0,
    0,    0, -306,    0,  -71,    0,  -58,    0,    0,  -16,
 -259,    0,    0,  130,    0,    0,    0,    0,    0,    0,
  -16,    0,    0,    0,    0,  -79,  -16,    0,    0,  611,
    0,  611,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  611,  611,  611,  611,  611,
  611,  611,  611,  611,  611,  611,  611,  611,  611,  611,
  611,  611,  611,  611,  611,    0,    0,    0,  611,  611,
    0,    0,  611, -236,  611,    0,  322,    0,    0,    0,
    0,    0,    0,    0,   76,    0,    0, -227,    0,    0,
  283,    0,    0,    0,    0,    0,    0,  643,  611,  643,
    0,    0,    0,    0, -166, -250,  617,    0,    0,  547,
    0,    0,   24,    0,    0,    0,    0,    0,  611,    0,
    0,    0, -269,    0,    0,  534,    0,    0,  611, -185,
    0,    0,    0,  617,    0,  564,    0,    0, -242,    0,
  534,    0,    0,    0,    0,    0,  -16,    0,    0,    0,
    0,  -16,    0,  -16,    0,    0,    0,    0, 3556,    0,
 1731, 1604, 1477, 4381, 4326, 4216, 4271,  770, 4051, 4106,
 4161, 3941, 3996, 3831, 3886, 3611, 3666, 3721, 3776,  992,
    0,    0,    0,    0,  534,    0,    0,   42,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  611,  611,    0, -222,  611,  402, -222,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  611, 4484,    0,
    0,    0,    0,    0,  602,    0,    0,  611,   46,    0,
    0,    0,    0,    0,    0, -306,    0,  130,  130,  130,
    0,    0,    0,    0,    0,    0,    0,    0,  -67,    0,
  684,    0,    0,    0,  -16,    0,    0,    0,    0,  611,
    0,    0,  611,    0,    0,    0, -257, -226,  611,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  611,    0,    0,
    0,    0, 4432,  640,  -81,  123,    0,  696,    0,    0,
  696,    0,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1852,
    0,    0,    0,    0,    0,  283,  283,  611, -222,    0,
    0, -224, 2872,    0, 2927, 3109,    0,  611,    0,   70,
  697,   -4,    0,  611,  699,    0,    0,    0,    0,    0,
    0,    0,    0,  203,    0,  533,    0,    0,    0,    0,
  718,    0,    0,  611,    0,    0,  611,    0,  611,    0,
    0, -245,    0,    0,    0,  613,  -73,    0,    0,    0,
  -78,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  723,  283,    0,    0,    0, -224,    0,  611,
    0,    0,  718,    0,  283,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  723,
    0,    0,    0,    0,    0,    0,    0,  322,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  322,    0,
    0,    0,    0,  283,  322,    0,    0,    0,  611,    0,
    0,  645,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  322,    0,    0,    0,
};
short yygindex[] = {                                      0,
  -26,    0,    0,  739,    0,    0,  -74,    0,  604, -217,
    1,    0,    0,    0,    0,  449,    0,    0,  435,    0,
    0,  200,    0,  444,    0,    0, -223,  624, -264,    0,
    0,    0,    0,    0,    0,  -40,    0,  -80,   -6, -156,
    0,    0,  849,    0, -132,  594,  597,  180,    0,  -30,
    0,  -75,  551,  623,    0,  631,  644,  520,    0, -297,
 -353,    3,  780,  772,    5,  589,    0,  620,    0,    0,
    0, 1032,    0,   50,    0, -447,    0,  558,    0,  550,
  549,    0,    0,  552, -247,    0,    0,  -70,    0,  957,
  -33,    0, -153,  794, -104,   10,   40, -429, -210,    0,
    0,
};
#define YYTABLESIZE 5078
short yytable[] = {                                      85,
  152,  176,  125,  404,  158,  115,   78,  155,   93,  131,
  435,  151,  126,  440,  189,  352,  293,  302,  354,  351,
  239,  242,  191,  307,  188,  188,  101,  308,  169,   13,
  131,  206,  206,  315,  125,  206,   85,  206,  297,  131,
  158,  393,  153,  180,  126,  128,  130,  424,  130,  171,
  181,  181,  538,  131,  136,  172,   98,   99,  131,  141,
  521,  144,  131,  258,   13,  131,  260,  131,  153,  176,
  142,  143,  145,  146,  147,  148,  149,  154,  384,   99,
   99,  180,  282,  185,  172,  553,  190,  280,  147,  131,
   85,  163,    7,  307,  240,  240,  169,  341,   27,   27,
  344,  279,   76,  206,  206,  206,  206,  206,  206,  206,
  206,  206,  206,  206,  206,  206,  206,  206,  206,  185,
  206,  176,  104,  181,   85,  145,  249,  250,  251,  252,
  253,  256,  449,  430,  147,  519,  609,    7,  523,  181,
  463,  257,  102,    7,  267,  375,  385,  475,  169,  125,
  188,  206,   99,  406,  190,  270,  283,  206,  414,  126,
  416,  618,  130,  186,  294,  299,  180,  384,   99,  303,
  304,  305,   27,  164,   76,  270,  181,  291,  122,  313,
  103,  272,   47,   85,   49,    7,  273,  293,    7,  293,
  302,  376,  317,  100,  100,  293,  319,  293,   96,  278,
  165,  183,  183,  540,  585,   99,  108,  108,  511,    7,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
   85,  116,  133,  340,  270,  403,    7,  270,  345,  348,
  418,  467,  468,  469,   85,  447,  419,  123,   34,   34,
  533,  363,  136,  356,  543,  302,  543,  293,  302,  144,
  302,  477,  150,  136,   15,  293,  100,  100,  100,  186,
  145,   96,   12,  159,  183,  183,  543,  186,  186,  108,
  108,  168,  380,  381,  413,  131,  169,  179,  128,  179,
  183,   41,  235,  389,    7,  108,  551,   24,   24,   12,
  179,  179,  131,  412,  282,  186,  184,  184,    2,  255,
  106,  106,  128,  128,  188,  282,   34,    3,    7,  130,
  125,  125,   34,  125,  125,  179,  125,  183,  156,  306,
  126,  126,  108,  126,  126,  294,  126,  294,   15,  128,
   15,   93,  374,  169,   93,    7,  239,  242,   32,   32,
   32,  589,  245,  503,   85,   85,  506,   85,   85,  131,
   85,  192,  179,  432,  433,  248,  128,  436,  600,  128,
  606,  179,   47,  156,  157,  179,  179,  179,  283,  184,
  184,  613,  270,  106,  106,  179,  247,  616,  125,  283,
  254,   16,  455,   16,  120,  184,  299,  261,  126,  106,
  120,    8,   47,  303,  157,  294,  626,  128,  128,  128,
  491,    7,  102,  128,  128,   47,  471,  417,  120,  120,
  240,  240,   85,  225,  480,  271,  226,  345,  274,  227,
  228,  484,  184,  398,  169,    7,  106,  158,  510,  158,
  158,  275,  513,  158,  277,  120,  120,  125,  125,  408,
  474,  125,  493,  287,  494,  495,  226,  126,  126,  227,
  228,  126,    7,  499,  222,  223,  224,  225,  120,  288,
  226,   47,  289,  227,  228,  262,  263,  264,  550,   85,
   85,   85,   85,  560,  561,   85,  516,  517,  497,  591,
  518,  128,  131,  159,  128,  159,  159,  577,  578,  159,
  522,  292,  532,  318,  537,  508,  541,   85,  541,  179,
  116,   26,   26,  342,  120,  120,  343,  125,  610,  125,
  120,  582,  583,  189,  353,  586,  357,  126,  541,  126,
  355,  537,   42,  537,  358,  182,  192,  183,  184,  359,
  595,  596,  597,  528,  531,  361,  362,   85,  549,  368,
  603,   85,  364,   85,  581,  555,  556,  365,   85,  559,
  128,  367,  587,  373,  567,  592,  377,  568,  614,  570,
  379,  383,  131,  159,  617,  159,  159,  399,  382,  159,
  387,   85,  394,  396,  179,  402,  598,  375,  625,  400,
   47,  576,   85,  401,  405,  179,  584,   85,   85,  421,
  407,  422,  179,  230,  615,  231,  232,  233,  425,  234,
  426,  131,  159,  537,  159,  159,  427,   85,  159,  428,
  602,  105,  106,  107,  108,  109,  179,  179,  431,  429,
  607,  608,   47,   47,  434,  441,  116,  220,  221,  222,
  223,  224,  225,  437,  442,  226,  444,  443,  227,  228,
  619,  445,  192,   12,  622,  446,  388,    8,  448,  472,
  476,    8,    8,    8,  473,  627,    8,    8,    8,    8,
    8,    8,  479,    8,    8,    8,    8,    8,    8,  485,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,  486,  487,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,  489,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,  488,  492,    8,    8,  206,  490,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  498,
    8,  226,  500,  502,  227,  228,  504,  505,  507,  512,
    8,    8,  172,  514,  515,   13,  524,    8,  527,    8,
    8,    8,  529,  192,  534,    8,  384,    8,   42,  544,
  546,    8,   42,   42,   42,  548,  554,   42,   42,   42,
   42,   42,   42,  557,   42,   42,   42,   42,   42,   42,
  558,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,  565,  572,   42,
   42,   42,   42,   42,  573,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,  574,  575,   42,   42,  593,
  604,  588,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  599,   42,  226,  605,  612,  227,  228,  620,  623,  624,
  131,   42,   42,  162,  192,    9,  130,   14,   42,   12,
   42,   42,   42,   12,   12,   12,   42,  131,   42,   12,
   12,   12,   42,   12,  178,   12,   12,   12,   12,   12,
   12,  149,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,  144,   95,
   12,   12,   12,   12,   12,   41,   12,   12,   12,   12,
   12,   12,   12,   12,   16,  178,   12,   15,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   82,  114,   12,   12,
  192,   87,  117,  118,  119,  120,  121,  288,   91,  372,
  466,  131,  132,  218,  219,  220,  221,  222,  223,  224,
  225,  590,   12,  226,  601,  594,  227,  228,  464,  296,
  482,  509,   12,   12,  483,  470,  465,  360,  451,   12,
  370,   12,   12,   12,  224,  224,  496,   12,  224,   12,
  224,  564,  481,   12,  181,  113,  187,    8,  124,   10,
  526,  542,  545,  371,    0,    0,  547,    0,    0,  244,
    0,    0,    0,   19,   20,    0,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,    0,    0,    0,    0,
    0,    0,  187,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,    0,    0,  226,
    0,    0,  227,  228,   48,  175,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,    0,  307,    0,  309,  310,
  311,  312,  314,    0,  316,    0,  176,    0,    0,    0,
    0,    0,    0,    0,  224,    0,    0,  177,    0,    0,
  224,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   10,   10,   10,    0,  178,  298,   10,
   10,   10,    0,   10,    0,   10,   10,   10,   10,   10,
   10,    0,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,    0,    0,
   10,   10,   10,   10,   10,    0,   10,   10,   10,   10,
   10,   10,   10,   10,    0,    0,   10,    0,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,    0,    0,   10,   10,
    0,    0,    0,    0,    0,    0,  194,  194,    0,    0,
  194,    0,  194,    0,    0,    0,    0,    0,    0,  415,
    0,    0,   10,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   10,   10,    0,    0,    0,    0,    0,   10,
    0,   10,   10,   10,    8,    9,   10,   10,    0,   10,
   11,   12,   13,   10,   14,    0,   15,   16,   17,   18,
   19,   20,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,    0,    0,   32,    0,  194,  194,
  194,    0,   33,   34,   35,   36,    0,   37,   38,   39,
   40,   41,   42,   43,   44,  194,    0,   45,    0,   46,
   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,   64,
   65,    0,    0,    0,    0,    0,  194,    0,    0,    0,
    0,    0,  194,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   67,   68,    0,  192,    0,    0,    0,
   69,    0,   70,   71,   72,    8,    9,   10,   73,    0,
   74,   11,   12,   13,   75,   14,    0,   15,   16,   17,
   18,   19,   20,    0,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,    0,    0,   32,    0,    0,
    0,    0,    0,   33,   34,   35,   36,    0,   37,   38,
   39,   40,   41,   42,   43,   44,    0,    0,   45,    0,
   46,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
   64,   65,    0,    0,    0,    0,  209,  210,  211,  212,
  213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,    0,   66,  226,    0,    0,  227,  228,
    0,    0,    0,    0,   67,   68,    0,  192,    0,    0,
    0,   69,    0,   70,   71,   72,    8,  124,   10,   73,
    0,   74,    0,   12,   13,   75,   14,    0,   15,   16,
   17,   18,   19,   20,    0,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   33,   34,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   44,    0,    0,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,   64,   65,    0,    0,    0,    0,    0,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,    0,   66,  226,    0,    0,  227,
  228,    0,    0,    0,    0,   67,   68,    0,    0,    0,
    0,    0,   69,    0,   70,   71,   72,    8,  124,   10,
  151,    0,   74,    0,   12,    0,   75,   14,    0,   15,
   16,   17,   18,   19,   20,    0,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   33,   34,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   44,    0,    0,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,  219,  219,    0,    0,  219,    0,  219,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   67,   68,    0,    0,
    0,    0,    0,   69,    0,   70,   71,   72,    0,    0,
    0,   73,    0,   74,    8,  124,   10,   75,    0,    0,
    0,   12,  388,  452,   14,    0,    0,    0,    0,    0,
   19,   20,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,  219,  219,  219,  219,  219,  219,  219,
  219,  219,  219,  219,  219,  219,  219,  219,  219,  219,
  219,  219,  219,  219,   44,    0,    0,    0,    0,    0,
  453,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,   64,
   65,  219,    0,    0,    0,    0,    0,  219,  220,  220,
    0,    0,  220,    0,  220,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   67,   68,    0,    0,    0,    0,    0,
   69,    0,   70,   71,   72,    0,    0,    0,  454,    0,
   74,    8,  124,   10,   75,    0,    0,    0,   12,  388,
  566,   14,    0,    0,    0,    0,    0,   19,   20,    0,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
    0,   44,    0,    0,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,   64,   65,  220,    0,
    0,    0,    0,    0,  220,  221,  221,    0,    0,  221,
    0,  221,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   68,    0,    0,    0,    0,    0,   69,    0,   70,
   71,   72,    0,    0,    0,   73,    0,   74,    8,  124,
   10,   75,    0,    0,    0,   12,  388,  569,   14,    0,
    0,    0,    0,    0,   19,   20,    0,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,    0,    0,   44,    0,
    0,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,   64,   65,  221,  216,  216,    0,    0,
  216,  221,  216,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   67,   68,    0,
    0,  192,    0,    0,   69,    0,   70,   71,   72,    8,
  124,   10,  454,    0,   74,    0,   12,    0,   75,   14,
    0,    0,    0,    0,    0,   19,   20,    0,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,  216,  216,
  216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
  216,  216,  216,  216,    0,  216,    0,    0,    0,   44,
    0,    0,    0,    0,  192,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,   64,   65,  216,    0,    0,    0,
    0,    0,  216,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,   66,    0,
  226,    0,    0,  227,  228,    0,    0,    0,   67,  266,
    0,    0,    0,    0,    0,   69,    0,   70,   71,   72,
    8,  124,   10,   73,  150,   74,    0,   12,  388,   75,
   14,    0,    0,    0,    0,    0,   19,   20,    0,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,    0,    0,  226,    0,    0,  227,  228,    0,    0,
   44,    0,    0,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   66,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   67,
   68,    0,    0,    0,    0,    0,   69,    0,   70,   71,
   72,    8,  124,   10,   73,    0,   74,    0,   12,  388,
   75,   14,    0,    0,    0,    0,    0,   19,   20,    0,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   44,    0,    0,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,   64,   65,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   68,    0,    0,    0,    0,    0,   69,    0,   70,
   71,   72,    8,  124,   10,  454,    0,   74,    0,   12,
    0,   75,   14,    0,    0,    0,    0,    0,   19,   20,
    0,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   44,    0,    0,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,   64,   65,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   67,   68,    0,    0,    0,    0,    0,   69,    0,
   70,   71,   72,    8,  124,   10,   73,    0,   74,    0,
   12,    0,   75,   14,    0,    0,    0,    0,    0,   19,
   20,    0,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   44,    0,    0,    0,    0,    0,   47,
   48,   49,    0,    0,   52,   53,   54,   55,   56,   57,
   58,   59,   60,   61,   62,   63,    0,    0,   64,   65,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   67,  266,    0,    8,  124,   10,    0,   69,
    0,   70,   71,   72,    0,   14,    0,   73,    0,   74,
    0,   19,   20,   75,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
   64,   65,    0,    0,    0,    0,    8,  124,   10,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   15,   16,
   17,   18,   19,   20,  176,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,  177,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   73,
    0,   74,    8,  124,   10,   75,    0,    0,    0,    0,
    0,    0,    0,   48,  175,    8,  124,   10,   19,   20,
    0,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   19,   20,    0,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  176,    0,    0,  408,  409,
  175,    0,    0,    0,    0,    0,  177,    0,    0,    0,
    0,    0,   48,  175,  274,  274,  274,    0,  274,    0,
  274,    0,    0,    0,    0,    0,  178,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  177,    0,  176,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  177,    0,    0,    0,   40,
   40,   40,  178,   40,    0,   40,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  178,  274,  274,  274,  274,
  274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
  274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
  274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
  274,  274,  274,    0,    0,  274,    0,    0,  274,  274,
  450,  192,    0,  274,  274,  274,  274,  274,    0,  274,
  274,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,    0,    0,
   40,    0,    0,   40,   40,    0,    0,    0,   40,   40,
   40,   40,   40,    0,   40,   40,  297,  297,  297,    0,
  297,    0,  297,    0,  193,  194,  195,  196,  197,  198,
  199,  200,  201,  202,  203,  204,  205,  206,    0,  207,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,    0,    0,
  226,    0,    0,  227,  228,    0,    0,    0,    0,    0,
    0,  282,  282,  282,    0,  282,    0,  282,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,    0,    0,  297,    0,    0,
  297,  297,    0,  192,    0,  297,  297,  297,  297,  297,
    0,  297,  297,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
    0,    0,  282,    0,    0,  282,  282,    0,    0,    0,
  282,  282,  282,  282,  282,    0,  282,  282,  193,  193,
  193,    0,  193,    0,  193,  259,  193,  194,  195,  196,
  197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
    0,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
    0,    0,  226,    0,    0,  227,  228,    0,    0,    0,
    0,    0,    0,  262,  262,  262,    0,  262,    0,  262,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  193,  193,  193,  193,  193,  193,  193,  193,  193,  193,
  193,  193,  193,  193,  193,  193,  193,  193,  193,  193,
  193,  193,  193,  193,  193,  193,  193,  193,  193,  193,
  193,  193,  193,  193,  193,  193,  193,    0,    0,  193,
    0,    0,  193,  193,    0,  197,  197,  197,  193,  197,
    0,  197,    0,    0,  193,  262,  262,  262,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,  262,
  262,  262,    0,    0,  262,    0,    0,  262,  262,    0,
  198,  198,  198,  262,  198,    0,  198,    0,    0,  262,
    0,    0,    0,    0,    0,    0,    0,  197,  197,  197,
  197,  197,  197,  197,  197,  197,  197,  197,  197,  197,
  197,  197,  197,  197,  197,  197,  197,  197,  197,  197,
  197,  197,  197,  197,  197,  197,  197,  197,  197,  197,
  197,  197,  197,  197,    0,  196,  196,  196,    0,  196,
    0,  196,    0,    0,    0,  197,    0,    0,    0,    0,
    0,  197,  198,  198,  198,  198,  198,  198,  198,  198,
  198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
  198,  198,  198,  198,  198,  198,  198,  198,  198,  198,
  198,  198,  198,  198,  198,  198,  198,  198,  198,    0,
  200,  200,  200,    0,  200,    0,  200,    0,    0,    0,
  198,    0,    0,    0,    0,    0,  198,  196,  196,  196,
  196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,    0,  199,  199,  199,    0,  199,
    0,  199,    0,    0,    0,  196,    0,    0,    0,    0,
    0,  196,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,    0,
  202,  202,  202,    0,  202,    0,  202,    0,    0,    0,
  200,    0,    0,    0,    0,    0,  200,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,    0,  204,  204,  204,    0,  204,
    0,  204,    0,    0,    0,  199,    0,    0,    0,    0,
    0,  199,  202,  202,  202,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  202,  202,    0,
  212,  212,  212,    0,  212,    0,  212,    0,    0,    0,
  202,    0,    0,    0,    0,    0,  202,  204,  204,  204,
  204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
  204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
  204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
  204,  204,  204,  204,    0,  209,  209,  209,    0,  209,
    0,  209,    0,    0,    0,  204,    0,    0,    0,    0,
    0,  204,  212,  212,  212,  212,  212,  212,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,    0,    0,
  210,  210,  210,    0,  210,    0,  210,    0,    0,    0,
  212,    0,    0,    0,    0,    0,  212,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
  209,  209,  209,    0,    0,  211,  211,  211,    0,  211,
    0,  211,    0,    0,    0,  209,    0,    0,    0,    0,
    0,  209,  210,  210,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,    0,    0,
  213,  213,  213,    0,  213,    0,  213,    0,    0,    0,
  210,    0,    0,    0,    0,    0,  210,  211,  211,  211,
  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
  211,  211,  211,    0,    0,  207,  207,    0,    0,  207,
    0,  207,    0,    0,    0,  211,    0,    0,    0,    0,
    0,  211,  213,  213,  213,  213,  213,  213,  213,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
  213,  213,  213,  213,  213,  213,  213,  213,    0,    0,
  208,  208,    0,    0,  208,    0,  208,    0,    0,    0,
  213,    0,    0,    0,    0,    0,  213,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
    0,    0,    0,    0,    0,  214,  214,    0,    0,  214,
    0,  214,    0,    0,    0,  207,    0,    0,    0,    0,
    0,  207,  208,  208,  208,  208,  208,  208,  208,  208,
  208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
  208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
  208,  208,  208,  208,  208,    0,    0,    0,    0,    0,
  215,  215,    0,    0,  215,    0,  215,    0,    0,    0,
  208,    0,    0,    0,    0,    0,  208,  214,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  214,    0,    0,
    0,    0,    0,    0,    0,  225,  225,    0,    0,  225,
    0,  225,    0,    0,    0,  214,    0,    0,    0,    0,
    0,  214,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,    0,    0,    0,    0,    0,    0,    0,
  226,  226,    0,    0,  226,    0,  226,    0,    0,    0,
  215,    0,    0,    0,    0,    0,  215,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  227,  227,    0,    0,  227,
    0,  227,    0,    0,    0,  225,    0,    0,    0,    0,
    0,  225,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  222,  222,    0,    0,  222,    0,  222,    0,    0,    0,
  226,    0,    0,    0,    0,    0,  226,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  223,  223,    0,    0,  223,
    0,  223,    0,    0,    0,  227,    0,    0,    0,    0,
    0,  227,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  218,  218,    0,    0,  218,    0,  218,    0,    0,    0,
  222,    0,    0,    0,    0,    0,  222,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  217,  217,    0,    0,  217,
    0,  217,    0,    0,    0,  223,    0,    0,    0,    0,
    0,  223,  218,  218,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,  218,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   39,    0,
   39,    0,   39,    0,    0,    0,    0,    0,    0,    0,
  218,    0,    0,    0,    0,    0,  218,  217,  217,  217,
  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
  217,  217,  217,  217,  217,  217,  217,  217,  217,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  261,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  217,    0,    0,   39,    0,
   39,  217,   39,   39,   39,   39,   39,   39,   39,   39,
   39,   39,   39,   39,   39,    0,   39,   39,   39,   39,
   39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
   39,   39,   39,   39,   39,  192,    0,   39,    0,  384,
   39,   39,    0,    0,    0,   39,    0,   39,   39,   39,
    0,   39,  261,  261,  261,  261,  261,  261,  261,  261,
  261,  261,  261,  261,  261,  261,  261,    0,  261,  261,
  261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
  261,  261,  261,  261,  261,  261,  261,  192,    0,  261,
    0,    0,  261,  261,    0,    0,    0,  261,    0,  261,
  261,  261,    0,  261,    0,    0,    0,  423,  193,  194,
  195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
  205,  206,    0,  207,  208,  209,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  192,    0,  226,    0,    0,  227,  228,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  378,
  193,  194,  195,  196,  197,  198,  199,  200,  201,  202,
  203,  204,  205,  206,    0,  207,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  192,    0,  226,    0,    0,  227,
  228,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  202,  203,  204,  205,  206,  420,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,    0,
    0,  226,    0,    0,  227,  228,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  193,  194,  195,
  196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
  206,    0,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,    0,    0,  226,    0,    0,  227,  228,
};
short yycheck[] = {                                       6,
   75,  271,   43,  301,   80,   32,    6,   78,    6,  316,
  364,  269,   43,  367,  266,  239,  170,  174,  242,  237,
  101,  102,   93,  269,  265,  266,  268,  181,  271,  268,
  290,  265,  266,  187,   75,  269,   43,  271,  171,  290,
  116,  289,  269,  266,   75,   43,  316,  345,   44,  384,
  265,  266,  500,  290,   50,  390,  265,  266,  316,   66,
  490,   68,  290,  134,  268,  290,  137,  290,   75,  339,
   66,   67,   68,   69,   70,   71,   72,   75,  271,  265,
  266,   88,  163,   90,  391,  515,  338,  162,  339,  316,
   97,   82,  265,  339,  101,  102,  339,  230,  265,  266,
  233,  340,  268,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  126,
  354,  391,  268,  338,  131,  385,  117,  118,  119,  120,
  121,  131,  380,  357,  385,  489,  340,  265,  492,  354,
  388,  132,  268,  316,  151,  339,  339,  412,  391,  190,
  391,  385,  338,  307,  391,  151,  163,  391,  312,  190,
  314,  609,  290,  391,  171,  172,  391,  271,  354,  176,
  177,  178,  339,  289,  340,  171,  391,  168,  266,  186,
  306,  386,  316,  190,  318,  265,  391,  269,  316,  271,
  269,  385,  190,  265,  266,  269,  192,  271,  266,  160,
  316,  265,  266,  501,  558,  391,  265,  266,  473,  289,
  206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  237,   32,  393,  229,  230,  339,  316,  233,  234,  235,
  316,  398,  399,  400,  251,  378,  317,  266,  316,  317,
  498,  251,  248,  244,  502,  337,  504,  339,  337,  266,
  339,  415,  385,  259,  269,  339,  338,  339,  340,   90,
  266,  339,  289,  266,  338,  339,  524,  265,  266,  338,
  339,  290,  273,  279,  311,  290,  386,   88,  265,   90,
  354,  268,  339,  289,  265,  354,  514,  265,  266,  316,
  101,  102,  290,  310,  385,  126,  265,  266,  256,  266,
  265,  266,  289,  290,  297,  396,  384,  265,  289,  290,
  361,  362,  390,  364,  365,  126,  367,  391,  317,  318,
  361,  362,  391,  364,  365,  269,  367,  271,  269,  316,
  271,  266,  385,  386,  269,  316,  427,  428,  316,  317,
  318,  562,  316,  458,  361,  362,  461,  364,  365,  290,
  367,  267,  163,  361,  362,  390,  364,  365,  579,  367,
  588,  172,  316,  317,  318,  176,  177,  178,  385,  338,
  339,  599,  378,  338,  339,  186,  316,  605,  429,  396,
  316,  269,  388,  271,  265,  354,  403,  339,  429,  354,
  271,    0,  316,  337,  318,  339,  624,  384,  385,  386,
  437,  265,  268,  390,  391,  316,  407,  318,  289,  290,
  427,  428,  429,  373,  420,  391,  376,  423,  391,  379,
  380,  429,  391,  385,  386,  289,  391,  291,  472,  293,
  294,  265,  476,  297,  393,  316,  317,  488,  489,  316,
  317,  492,  443,  316,  445,  446,  376,  488,  489,  379,
  380,  492,  316,  454,  370,  371,  372,  373,  339,  390,
  376,  269,  340,  379,  380,  316,  317,  318,  512,  486,
  487,  488,  489,  311,  312,  492,  486,  487,  449,  564,
  488,  489,  290,  291,  492,  293,  294,  311,  312,  297,
  491,  316,  498,  265,  500,  466,  502,  514,  504,  310,
  311,  265,  266,  316,  385,  386,  316,  558,  593,  560,
  391,  555,  556,  266,  269,  559,  339,  558,  524,  560,
  269,  527,    0,  529,  269,  291,  267,  293,  294,  390,
  574,  575,  576,  494,  495,  390,  390,  554,  509,  266,
  584,  558,  390,  560,  554,  516,  517,  390,  565,  520,
  558,  390,  560,  393,  525,  565,  385,  528,  602,  530,
  316,  391,  290,  291,  608,  293,  294,  385,  316,  297,
  390,  588,  339,  390,  385,  391,  577,  339,  622,  385,
  269,  552,  599,  316,  391,  396,  557,  604,  605,  385,
  316,  385,  403,  384,  604,  386,  387,  388,  391,  390,
  269,  290,  291,  609,  293,  294,  266,  624,  297,  266,
  581,  321,  322,  323,  324,  325,  427,  428,  391,  390,
  591,  592,  311,  312,  303,  265,  437,  368,  369,  370,
  371,  372,  373,  314,  265,  376,  370,  391,  379,  380,
  611,  391,  267,    0,  615,  391,  268,  256,  391,  266,
  266,  260,  261,  262,  339,  626,  265,  266,  267,  268,
  269,  270,  265,  272,  273,  274,  275,  276,  277,  266,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  391,  391,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  266,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  390,  266,  335,  336,  353,  391,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  340,
  359,  376,  339,  339,  379,  380,  337,  339,  391,  266,
  369,  370,  390,  268,  391,  268,  268,  376,  268,  378,
  379,  380,  268,  267,  316,  384,  271,  386,  256,  269,
  316,  390,  260,  261,  262,  269,  302,  265,  266,  267,
  268,  269,  270,  391,  272,  273,  274,  275,  276,  277,
  266,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  391,  339,  297,
  298,  299,  300,  301,  269,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  266,  269,  335,  336,  385,
  391,  354,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  354,  359,  376,  354,  316,  379,  380,  316,  269,  354,
  290,  369,  370,  297,  267,  265,  290,  265,  376,  256,
  378,  379,  380,  260,  261,  262,  384,  316,  386,  266,
  267,  268,  390,  270,  391,  272,  273,  274,  275,  276,
  277,  385,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  385,  266,
  297,  298,  299,  300,  301,  316,  303,  304,  305,  306,
  307,  308,  309,  310,  269,  269,  313,  269,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  269,   31,  335,  336,
  267,  269,   36,   37,   38,   39,   40,  385,  354,  261,
  397,   45,   46,  366,  367,  368,  369,  370,  371,  372,
  373,  563,  359,  376,  580,  572,  379,  380,  395,  171,
  427,  471,  369,  370,  428,  403,  396,  248,  385,  376,
  259,  378,  379,  380,  265,  266,  448,  384,  269,  386,
  271,  522,  423,  390,   88,   14,   90,  260,  261,  262,
  493,  502,  504,  260,   -1,   -1,  505,   -1,   -1,  103,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,
   -1,   -1,  126,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,   -1,   -1,  376,
   -1,   -1,  379,  380,  317,  318,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,   -1,  180,   -1,  182,  183,
  184,  185,  186,   -1,  188,   -1,  359,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  385,   -1,   -1,  370,   -1,   -1,
  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,  261,  262,   -1,  390,  391,  266,
  267,  268,   -1,  270,   -1,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,   -1,   -1,
  297,  298,  299,  300,  301,   -1,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,   -1,  313,   -1,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,   -1,  335,  336,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,  313,
   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,  376,
   -1,  378,  379,  380,  260,  261,  262,  384,   -1,  386,
  266,  267,  268,  390,  270,   -1,  272,  273,  274,  275,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,  292,   -1,  337,  338,
  339,   -1,  298,  299,  300,  301,   -1,  303,  304,  305,
  306,  307,  308,  309,  310,  354,   -1,  313,   -1,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,   -1,   -1,  335,
  336,   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  369,  370,   -1,  267,   -1,   -1,   -1,
  376,   -1,  378,  379,  380,  260,  261,  262,  384,   -1,
  386,  266,  267,  268,  390,  270,   -1,  272,  273,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,   -1,   -1,  298,  299,  300,  301,   -1,  303,  304,
  305,  306,  307,  308,  309,  310,   -1,   -1,  313,   -1,
  315,  316,  317,  318,   -1,   -1,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,   -1,   -1,
  335,  336,   -1,   -1,   -1,   -1,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,   -1,  359,  376,   -1,   -1,  379,  380,
   -1,   -1,   -1,   -1,  369,  370,   -1,  267,   -1,   -1,
   -1,  376,   -1,  378,  379,  380,  260,  261,  262,  384,
   -1,  386,   -1,  267,  268,  390,  270,   -1,  272,  273,
  274,  275,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,
   -1,   -1,  316,  317,  318,   -1,   -1,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,   -1,
   -1,  335,  336,   -1,   -1,   -1,   -1,   -1,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,   -1,  359,  376,   -1,   -1,  379,
  380,   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,   -1,
   -1,   -1,  376,   -1,  378,  379,  380,  260,  261,  262,
  384,   -1,  386,   -1,  267,   -1,  390,  270,   -1,  272,
  273,  274,  275,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,
   -1,   -1,   -1,  316,  317,  318,   -1,   -1,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
   -1,   -1,  335,  336,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,
   -1,   -1,   -1,  376,   -1,  378,  379,  380,   -1,   -1,
   -1,  384,   -1,  386,  260,  261,  262,  390,   -1,   -1,
   -1,  267,  268,  269,  270,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  310,   -1,   -1,   -1,   -1,   -1,
  316,  317,  318,   -1,   -1,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,   -1,   -1,  335,
  336,  385,   -1,   -1,   -1,   -1,   -1,  391,  265,  266,
   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,
  376,   -1,  378,  379,  380,   -1,   -1,   -1,  384,   -1,
  386,  260,  261,  262,  390,   -1,   -1,   -1,  267,  268,
  269,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
   -1,   -1,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,   -1,   -1,  335,  336,  385,   -1,
   -1,   -1,   -1,   -1,  391,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  369,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,
  379,  380,   -1,   -1,   -1,  384,   -1,  386,  260,  261,
  262,  390,   -1,   -1,   -1,  267,  268,  269,  270,   -1,
   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,   -1,   -1,  310,   -1,
   -1,   -1,   -1,   -1,  316,  317,  318,   -1,   -1,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  332,   -1,   -1,  335,  336,  385,  265,  266,   -1,   -1,
  269,  391,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,   -1,
   -1,  267,   -1,   -1,  376,   -1,  378,  379,  380,  260,
  261,  262,  384,   -1,  386,   -1,  267,   -1,  390,  270,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,   -1,  354,   -1,   -1,   -1,  310,
   -1,   -1,   -1,   -1,  267,  316,  317,  318,   -1,   -1,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,   -1,   -1,  335,  336,  385,   -1,   -1,   -1,
   -1,   -1,  391,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  359,   -1,
  376,   -1,   -1,  379,  380,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,  379,  380,
  260,  261,  262,  384,  385,  386,   -1,  267,  268,  390,
  270,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,   -1,   -1,  376,   -1,   -1,  379,  380,   -1,   -1,
  310,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,   -1,
   -1,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,   -1,   -1,  335,  336,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,
  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,  379,
  380,  260,  261,  262,  384,   -1,  386,   -1,  267,  268,
  390,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
   -1,   -1,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,   -1,   -1,  335,  336,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  369,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,
  379,  380,  260,  261,  262,  384,   -1,  386,   -1,  267,
   -1,  390,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,  317,
  318,   -1,   -1,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,   -1,   -1,  335,  336,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,
  378,  379,  380,  260,  261,  262,  384,   -1,  386,   -1,
  267,   -1,  390,  270,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,
  317,  318,   -1,   -1,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,   -1,  335,  336,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  369,  370,   -1,  260,  261,  262,   -1,  376,
   -1,  378,  379,  380,   -1,  270,   -1,  384,   -1,  386,
   -1,  276,  277,  390,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  316,  317,  318,   -1,   -1,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,   -1,   -1,
  335,  336,   -1,   -1,   -1,   -1,  260,  261,  262,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,
  274,  275,  276,  277,  359,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  370,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  384,
   -1,  386,  260,  261,  262,  390,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  317,  318,  260,  261,  262,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,  316,  317,
  318,   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,
   -1,   -1,  317,  318,  265,  266,  267,   -1,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  370,   -1,  359,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,  265,
  266,  267,  390,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,   -1,   -1,  376,   -1,   -1,  379,  380,
  266,  267,   -1,  384,  385,  386,  387,  388,   -1,  390,
  391,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,   -1,   -1,
  376,   -1,   -1,  379,  380,   -1,   -1,   -1,  384,  385,
  386,  387,  388,   -1,  390,  391,  265,  266,  267,   -1,
  269,   -1,  271,   -1,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,   -1,   -1,
  376,   -1,   -1,  379,  380,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,   -1,   -1,  376,   -1,   -1,
  379,  380,   -1,  267,   -1,  384,  385,  386,  387,  388,
   -1,  390,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
   -1,   -1,  376,   -1,   -1,  379,  380,   -1,   -1,   -1,
  384,  385,  386,  387,  388,   -1,  390,  391,  265,  266,
  267,   -1,  269,   -1,  271,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
   -1,   -1,  376,   -1,   -1,  379,  380,   -1,   -1,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,   -1,   -1,  376,
   -1,   -1,  379,  380,   -1,  265,  266,  267,  385,  269,
   -1,  271,   -1,   -1,  391,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,   -1,   -1,  376,   -1,   -1,  379,  380,   -1,
  265,  266,  267,  385,  269,   -1,  271,   -1,   -1,  391,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,   -1,  265,  266,  267,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,   -1,
  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,   -1,  265,  266,  267,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,   -1,
  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,   -1,  265,  266,  267,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,   -1,
  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,   -1,  265,  266,  267,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,   -1,
  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,   -1,   -1,  265,  266,  267,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,   -1,
  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,   -1,   -1,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,   -1,
  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,   -1,   -1,   -1,   -1,   -1,
  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,   -1,
   -1,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,  337,   -1,
  339,  391,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  267,   -1,  376,   -1,  271,
  379,  380,   -1,   -1,   -1,  384,   -1,  386,  387,  388,
   -1,  390,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  267,   -1,  376,
   -1,   -1,  379,  380,   -1,   -1,   -1,  384,   -1,  386,
  387,  388,   -1,  390,   -1,   -1,   -1,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  267,   -1,  376,   -1,   -1,  379,  380,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,   -1,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  267,   -1,  376,   -1,   -1,  379,
  380,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,   -1,
   -1,  376,   -1,   -1,  379,  380,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,   -1,   -1,  376,   -1,   -1,  379,  380,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 393
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","NL","SEMI","MOD","OC","CC","DOLLAR","DOTS",
"GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL","RATIONAL","REAL",
"STRING","FILET","MUTEX","SEMAPHORE","CONTINUATION","THREAD","VOID","BOOL",
"FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT","NEW","ANONINIT",
"NAMESPACE","PUBLIC","PROTECTED","EXTEND","IF","ELSE","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TRY","CATCH",
"TWIXT","NAME","TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM",
"OCTAL0_NUM","OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT",
"OCTAL_FLOAT","BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST",
"POLY_CONST","THREAD_CONST","VOIDVAL","BOOLVAL","DARROW","POUND","COMMA",
"ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES","ASSIGNDIVIDE","ASSIGNDIV",
"ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL","ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND",
"ASSIGNLOR","QUEST","COLON","OR","AND","LOR","LXOR","LAND","EQ","NE","LT","GT",
"LE","GE","SHIFTL","SHIFTR","PLUS","MINUS","TIMES","DIVIDE","DIV","POW",
"UNIONCAST","UMINUS","BANG","FACT","LNOT","INC","DEC","STAR","AMPER","THREADID",
"OS","CS","DOT","ARROW","STAROS","CALL","OP","CP","POINTER","COLONCOLON",
};
char *yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"statement : IF ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"statement : IF ignorenl namespace_start OP expr CP statement ELSE statement namespace_end attendnl",
"statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"statement : FOR ignorenl namespace_start OP opt_expr SEMI opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"statement : UNION SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"statement : BREAK SEMI",
"statement : CONTINUE SEMI",
"statement : RETURNTOK opt_expr SEMI",
"statement : expr SEMI",
"statement : block",
"statement : SEMI",
"statement : func_decl opt_func_body namespace_end",
"statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end SEMI attendnl",
"statement : RAISE fullname OP opt_exprs CP SEMI",
"statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"statement : opt_publish IMPORT ignorenl fullname SEMI attendnl",
"statement : TRY ignorenl statement catches attendnl",
"statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : ASSIGN simpleexpr SEMI",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish class type ignorenl opt_nl",
"decl : class type ignorenl opt_nl",
"decl : publish type ignorenl opt_nl",
"decl : type ignorenl opt_nl",
"decl : publish class ignorenl opt_nl",
"decl : class ignorenl opt_nl",
"decl : publish ignorenl opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : LAND type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dots",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : argdefines",
"opt_argdefines :",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dots",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dots : DOTS",
"opt_dots :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dots",
"simpleexpr : primary",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr POW simpleexpr",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGN",
"primary : fullname",
"primary : TEN_NUM",
"primary : OCTAL_NUM",
"primary : OCTAL0_NUM",
"primary : BINARY_NUM",
"primary : HEX_NUM",
"primary : TEN_FLOAT",
"primary : OCTAL_FLOAT",
"primary : OCTAL0_FLOAT",
"primary : BINARY_FLOAT",
"primary : HEX_FLOAT",
"primary : CHAR_CONST",
"primary : STRING_CONST",
"primary : VOIDVAL",
"primary : BOOLVAL",
"primary : OS CS",
"primary : OP type CP namespace_start init namespace_end",
"primary : OP OS stars CS CP namespace_start arrayinit namespace_end",
"primary : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"primary : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"primary : type DOT NAME",
"primary : OP type DOT NAME CP primary",
"primary : DOLLAR opt_integer",
"primary : DOT",
"primary : OP expr CP",
"primary : OP block CP",
"primary : primary STAROS dims CS",
"primary : primary OS dims CS",
"primary : primary OP opt_actuals CP",
"primary : primary DOT NAME",
"primary : primary ARROW NAME",
"primary : opt_type FUNC namespace_start args func_body namespace_end",
"opt_integer : integer",
"opt_integer :",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dots CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : hashvalue DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1486 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    BoxValueSet (array->array.values, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	BoxValueSet (array->array.values, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ParseError ("%s before %S", msg, yytext);
}
#line 2392 "gram.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 197 "gram.y"
{ yyerrok; }
break;
case 6:
#line 199 "gram.y"
{ yyerrok; }
break;
case 7:
#line 207 "gram.y"
{ ignorenl++; }
break;
case 8:
#line 210 "gram.y"
{ ignorenl--; }
break;
case 9:
#line 213 "gram.y"
{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
		    }
break;
case 10:
#line 223 "gram.y"
{ notCommand = 1; }
break;
case 17:
#line 238 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yyvsp[-2].expr, 0));
			GetNamespace (&s, &f);
			t = NewThread (f, CompileExpr (e, 0));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 18:
#line 253 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yyvsp[-4].expr, 0), yyvsp[-2].expr);
			GetNamespace (&s, &f);
			t = NewThread (f, CompileExpr (e, 0));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 268 "gram.y"
{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr    f;
			Value	    t;
			
			GetNamespace (&s, &f);
			t = NewThread (f, CompileStat (yyvsp[-2].expr, 0));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 280 "gram.y"
{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CommandPtr	c;

			c = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!c)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, c->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f);
			    t = NewThread (f, CompileExpr (e, 0));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 21:
#line 303 "gram.y"
{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CommandPtr	c;

			c = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!c)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, c->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f);
			    t = NewThread (f, CompileExpr (e, 0));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 24:
#line 330 "gram.y"
{ yyval.expr = 0; }
break;
case 25:
#line 333 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 26:
#line 335 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 27:
#line 338 "gram.y"
{ yyval.expr = BuildRawname (yyvsp[-1].expr, yyvsp[0].atom); }
break;
case 31:
#line 345 "gram.y"
{ yyval.expr = NewExprTree (COLONCOLON, yyvsp[-2].expr, NewExprAtom (yyvsp[-1].atom, 0, False)); }
break;
case 32:
#line 347 "gram.y"
{ yyval.expr = 0; }
break;
case 33:
#line 350 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 34:
#line 355 "gram.y"
{ 
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 35:
#line 361 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 366 "gram.y"
{
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 372 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yyvsp[-2].expr, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 38:
#line 395 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 41:
#line 425 "gram.y"
{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 42:
#line 428 "gram.y"
{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 43:
#line 431 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 46:
#line 438 "gram.y"
{ yyval.expr = NewExprTree(OC, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 47:
#line 440 "gram.y"
{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 48:
#line 443 "gram.y"
{ yyval.expr = NewExprTree(IF, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 49:
#line 445 "gram.y"
{ yyval.expr = NewExprTree(ELSE, yyvsp[-6].expr, NewExprTree(ELSE, yyvsp[-4].expr, yyvsp[-2].expr)); }
break;
case 50:
#line 447 "gram.y"
{ yyval.expr = NewExprTree(WHILE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 51:
#line 449 "gram.y"
{ yyval.expr = NewExprTree(DO, yyvsp[-6].expr, yyvsp[-3].expr); }
break;
case 52:
#line 451 "gram.y"
{ yyval.expr = NewExprTree(FOR, NewExprTree(FOR, yyvsp[-8].expr, yyvsp[-6].expr),
				       NewExprTree(FOR, yyvsp[-4].expr, yyvsp[-2].expr));
		    }
break;
case 53:
#line 455 "gram.y"
{ yyval.expr = NewExprTree (SWITCH, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 54:
#line 457 "gram.y"
{ yyval.expr = NewExprTree (UNION, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 55:
#line 459 "gram.y"
{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 56:
#line 461 "gram.y"
{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 57:
#line 463 "gram.y"
{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yyvsp[-1].expr); }
break;
case 58:
#line 465 "gram.y"
{ yyval.expr = NewExprTree(EXPR, yyvsp[-1].expr, (Expr *) 0); }
break;
case 60:
#line 468 "gram.y"
{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 61:
#line 470 "gram.y"
{ 
			DeclList    *decl = yyvsp[-2].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yyvsp[-2].funcDecl.type.class;
			Publish	    publish = yyvsp[-2].funcDecl.type.publish;
			TypePtr	    type = yyvsp[-2].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yyvsp[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yyvsp[-1].expr),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 62:
#line 496 "gram.y"
{ 
			DeclListPtr decl;

			decl = NewDeclList (yyvsp[-5].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yyvsp[-8].publish, 
						       class_exception, 
						       typePoly, yyvsp[-5].atom);
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yyvsp[-3].argType),
					  yyvsp[-8].publish);
		    }
break;
case 63:
#line 510 "gram.y"
{ yyval.expr = NewExprTree (RAISE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 64:
#line 512 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, 0, yyvsp[-5].publish), 0);
		    }
break;
case 65:
#line 521 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-6].publish, class_typedef,
							   yyvsp[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, yyvsp[-3].type, yyvsp[-6].publish), 0);
		    }
break;
case 66:
#line 530 "gram.y"
{
			SymbolPtr   symbol;
			Publish	    publish = yyvsp[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yyvsp[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yyvsp[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yyvsp[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yyvsp[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].publish, class_namespace,
						     0, yyvsp[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yyvsp[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 67:
#line 571 "gram.y"
{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yyvsp[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yyvsp[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yyvsp[-5].atom, 0, False), yyvsp[-2].expr);
		    }
break;
case 68:
#line 585 "gram.y"
{
			SymbolPtr	symbol;
			ExprPtr		e;

			e = yyvsp[-2].expr;
			if (yyvsp[-2].expr->base.tag == COLONCOLON)
			    e = e->tree.right;
			symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace %A", e->atom.atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", e->atom.atom);
			    YYERROR;
			}
			NamespaceImport (CurrentNamespace, 
					 symbol->namespace.namespace, yyvsp[-5].publish);
			yyval.expr = NewExprTree (IMPORT, yyvsp[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yyvsp[-5].publish));
		    }
break;
case 69:
#line 612 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[-2].expr); }
break;
case 70:
#line 614 "gram.y"
{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yyvsp[-6].expr, yyvsp[-4].expr),
					NewExprTree (TWIXT, yyvsp[-2].expr, 0));
		    }
break;
case 71:
#line 620 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 72:
#line 622 "gram.y"
{ yyval.expr = 0; }
break;
case 73:
#line 625 "gram.y"
{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void], yyvsp[-2].argType, yyvsp[-1].expr), yyvsp[-4].expr); }
break;
case 75:
#line 629 "gram.y"
{ yyval.expr = 0; }
break;
case 76:
#line 631 "gram.y"
{ ++funcDepth; }
break;
case 77:
#line 631 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 78:
#line 634 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 79:
#line 636 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 80:
#line 643 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 81:
#line 646 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 82:
#line 648 "gram.y"
{ yyval.expr = 0; }
break;
case 83:
#line 651 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 84:
#line 653 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 85:
#line 656 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 86:
#line 659 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 87:
#line 661 "gram.y"
{ yyval.expr = 0; }
break;
case 88:
#line 664 "gram.y"
{ 
			SymbolPtr   sym = yyvsp[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yyvsp[-4].atom, 0, False),
						       name),
					  yyvsp[-1].expr);
		    }
break;
case 89:
#line 679 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 90:
#line 682 "gram.y"
{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yyvsp[0].atom);
		    }
break;
case 91:
#line 689 "gram.y"
{ yyval.symbol = 0; }
break;
case 92:
#line 695 "gram.y"
{ yyval.atomList = NewAtomList (yyvsp[0].atomList, yyvsp[-2].atom); }
break;
case 93:
#line 697 "gram.y"
{ yyval.atomList = NewAtomList (0, yyvsp[0].atom); }
break;
case 94:
#line 700 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[-2].atom, 0, yyvsp[0].declList); }
break;
case 95:
#line 702 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[0].atom, 0, 0); }
break;
case 98:
#line 715 "gram.y"
{ 
			if (yyvsp[-3].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-3].symbol->symbol.name, yyvsp[-2].expr, yyvsp[0].declList); 
			    yyval.declList->symbol = yyvsp[-3].symbol;
			}
			else
			    yyval.declList = yyvsp[0].declList;
		    }
break;
case 99:
#line 725 "gram.y"
{ 
			if (yyvsp[-1].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-1].symbol->symbol.name, yyvsp[0].expr, 0);
			    yyval.declList->symbol = yyvsp[-1].symbol;
			}
			else
			    yyvsp[-1].symbol = 0;
		    }
break;
case 100:
#line 736 "gram.y"
{	
			yyval.symbol = ParseNewSymbol (yyvsp[-1].fulltype.publish,
					     yyvsp[-1].fulltype.class,
					     yyvsp[-1].fulltype.type,
					     yyvsp[0].atom);
		    }
break;
case 101:
#line 748 "gram.y"
{ yyval.fulltype = yyvsp[-3].fulltype; }
break;
case 102:
#line 754 "gram.y"
{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yyvsp[-3].funcDecl.type.type, yyvsp[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yyvsp[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yyvsp[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].funcDecl.type.publish,
						     yyvsp[-3].funcDecl.type.class, 
						     type,
						     yyvsp[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yyvsp[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 103:
#line 787 "gram.y"
{ yyval.funcDecl.type = yyvsp[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 104:
#line 789 "gram.y"
{ yyval.funcDecl.type = yyvsp[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 105:
#line 791 "gram.y"
{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); 
		    }
break;
case 106:
#line 799 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 107:
#line 801 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 108:
#line 803 "gram.y"
{ yyval.expr = 0; }
break;
case 109:
#line 809 "gram.y"
{ yyval.fulltype.publish = yyvsp[-4].publish; yyval.fulltype.class = yyvsp[-3].class; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 110:
#line 811 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-3].class; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 111:
#line 813 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 112:
#line 815 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 113:
#line 817 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = typePoly; }
break;
case 114:
#line 819 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = typePoly; }
break;
case 115:
#line 821 "gram.y"
{ yyval.fulltype.publish = yyvsp[-2].publish; yyval.fulltype.class = class_undef; yyval.fulltype.type = typePoly; }
break;
case 116:
#line 827 "gram.y"
{ yyval.type = NewTypeFunc (yyvsp[0].type, yyvsp[-1].argType); }
break;
case 117:
#line 829 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr); }
break;
case 118:
#line 831 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr); }
break;
case 119:
#line 833 "gram.y"
{ yyval.type = NewTypeHash (yyvsp[0].type, yyvsp[-2].type); }
break;
case 120:
#line 835 "gram.y"
{ yyval.type = 0; }
break;
case 121:
#line 838 "gram.y"
{
			Type	*top = yyvsp[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yyvsp[-1].type;
			yyval.type = top;
		    }
break;
case 122:
#line 866 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, True); }
break;
case 123:
#line 868 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, False); }
break;
case 125:
#line 872 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 126:
#line 898 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 127:
#line 924 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 128:
#line 945 "gram.y"
{ yyval.type = yyvsp[-1].type; }
break;
case 129:
#line 947 "gram.y"
{ yyval.type = NewTypeName (yyvsp[0].expr, 0); }
break;
case 131:
#line 951 "gram.y"
{ yyval.type = typePoly; }
break;
case 145:
#line 968 "gram.y"
{ yyval.expr = 0; }
break;
case 146:
#line 971 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 147:
#line 973 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 148:
#line 976 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 149:
#line 978 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 150:
#line 984 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 151:
#line 986 "gram.y"
{ yyval.memList = 0; }
break;
case 152:
#line 989 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 153:
#line 991 "gram.y"
{ yyval.memList = 0; }
break;
case 159:
#line 1004 "gram.y"
{ yyval.publish = publish_private; }
break;
case 164:
#line 1018 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 165:
#line 1020 "gram.y"
{ yyval.argType = 0; }
break;
case 166:
#line 1023 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 167:
#line 1025 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 168:
#line 1028 "gram.y"
{ 
			ParseCanonType (yyvsp[-1].type, False);
			yyval.argDecl.type = yyvsp[-1].type; 
			yyval.argDecl.name = yyvsp[0].atom; 
		    }
break;
case 169:
#line 1034 "gram.y"
{ 
			ParseCanonType (yyvsp[0].type, False);
			yyval.argDecl.type = yyvsp[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 170:
#line 1045 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 171:
#line 1048 "gram.y"
{
			ArgType	*args;
			Type	*type;

			for (args = yyvsp[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0));
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yyvsp[0].argType;
		    }
break;
case 172:
#line 1072 "gram.y"
{ yyval.argType = 0; }
break;
case 173:
#line 1075 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 174:
#line 1077 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 175:
#line 1080 "gram.y"
{ yyval.argDecl.type = yyvsp[-1].type; yyval.argDecl.name = yyvsp[0].atom; }
break;
case 176:
#line 1082 "gram.y"
{ yyval.argDecl.type = yyvsp[0].type; yyval.argDecl.name = 0; }
break;
case 177:
#line 1085 "gram.y"
{ yyval.bool = True; }
break;
case 178:
#line 1087 "gram.y"
{ yyval.bool = False; }
break;
case 180:
#line 1095 "gram.y"
{ yyval.expr = 0; }
break;
case 182:
#line 1099 "gram.y"
{ 
			DeclList    *decl;

			for (decl = yyvsp[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yyvsp[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yyvsp[0].declList, yyvsp[-1].fulltype.class, yyvsp[-1].fulltype.type, yyvsp[-1].fulltype.publish); 
		    }
break;
case 184:
#line 1116 "gram.y"
{ yyval.expr = NewExprTree(COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 186:
#line 1123 "gram.y"
{ yyval.expr = 0; }
break;
case 187:
#line 1126 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 188:
#line 1128 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 190:
#line 1132 "gram.y"
{ yyval.expr = 0; }
break;
case 191:
#line 1135 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 192:
#line 1137 "gram.y"
{	
			ExprPtr	arg = yyvsp[0].bool ? NewExprTree (DOTS, yyvsp[-1].expr, 0) : yyvsp[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 194:
#line 1147 "gram.y"
{ 
			if (yyvsp[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yyvsp[-2].expr, yyvsp[0].expr));
			else
			{
			    ExprPtr left = yyvsp[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yyvsp[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yyvsp[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yyvsp[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yyvsp[-1].ints, yyvsp[-2].expr, yyvsp[0].expr); 
			}
		    }
break;
case 195:
#line 1173 "gram.y"
{   Value	t;
			t = do_Thread_id_to_thread (yyvsp[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yyvsp[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 196:
#line 1184 "gram.y"
{ yyval.expr = NewExprTree(STAR, yyvsp[0].expr, (Expr *) 0); }
break;
case 197:
#line 1186 "gram.y"
{ yyval.expr = NewExprTree(AMPER, yyvsp[0].expr, (Expr *) 0); }
break;
case 198:
#line 1188 "gram.y"
{ yyval.expr = NewExprTree(UMINUS, yyvsp[0].expr, (Expr *) 0); }
break;
case 199:
#line 1190 "gram.y"
{ yyval.expr = NewExprTree(LNOT, yyvsp[0].expr, (Expr *) 0); }
break;
case 200:
#line 1192 "gram.y"
{ yyval.expr = NewExprTree(BANG, yyvsp[0].expr, (Expr *) 0); }
break;
case 201:
#line 1194 "gram.y"
{ yyval.expr = NewExprTree(FACT, yyvsp[-1].expr, (Expr *) 0); }
break;
case 202:
#line 1196 "gram.y"
{ yyval.expr = NewExprTree(INC, yyvsp[0].expr, (Expr *) 0); }
break;
case 203:
#line 1198 "gram.y"
{ yyval.expr = NewExprTree(INC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 204:
#line 1200 "gram.y"
{ yyval.expr = NewExprTree(DEC, yyvsp[0].expr, (Expr *) 0); }
break;
case 205:
#line 1202 "gram.y"
{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 206:
#line 1204 "gram.y"
{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yyvsp[0].expr); }
break;
case 207:
#line 1206 "gram.y"
{ yyval.expr = NewExprTree(PLUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 208:
#line 1208 "gram.y"
{ yyval.expr = NewExprTree(MINUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 209:
#line 1210 "gram.y"
{ yyval.expr = NewExprTree(TIMES, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 210:
#line 1212 "gram.y"
{ yyval.expr = NewExprTree(DIVIDE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 211:
#line 1214 "gram.y"
{ yyval.expr = NewExprTree(DIV, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 212:
#line 1216 "gram.y"
{ yyval.expr = NewExprTree(MOD, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 213:
#line 1218 "gram.y"
{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yyvsp[-2].expr, yyvsp[0].expr)); 
		    }
break;
case 214:
#line 1224 "gram.y"
{ yyval.expr = NewExprTree(SHIFTL, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 215:
#line 1226 "gram.y"
{ yyval.expr = NewExprTree(SHIFTR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 216:
#line 1228 "gram.y"
{ yyval.expr = NewExprTree(QUEST, yyvsp[-4].expr, NewExprTree(COLON, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 217:
#line 1230 "gram.y"
{ yyval.expr = NewExprTree(LXOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 218:
#line 1232 "gram.y"
{ yyval.expr = NewExprTree(LAND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 219:
#line 1234 "gram.y"
{ yyval.expr = NewExprTree(LOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 220:
#line 1236 "gram.y"
{ yyval.expr = NewExprTree(AND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 221:
#line 1238 "gram.y"
{ yyval.expr = NewExprTree(OR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 222:
#line 1240 "gram.y"
{ yyval.expr = NewExprTree(EQ, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 223:
#line 1242 "gram.y"
{ yyval.expr = NewExprTree(NE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 224:
#line 1244 "gram.y"
{ yyval.expr = NewExprTree(LT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 225:
#line 1246 "gram.y"
{ yyval.expr = NewExprTree(GT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 226:
#line 1248 "gram.y"
{ yyval.expr = NewExprTree(LE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 227:
#line 1250 "gram.y"
{ yyval.expr = NewExprTree(GE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 242:
#line 1268 "gram.y"
{ yyval.expr = NewExprConst(TEN_NUM, yyvsp[0].value); }
break;
case 243:
#line 1270 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_NUM, yyvsp[0].value); }
break;
case 244:
#line 1272 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_NUM, yyvsp[0].value); }
break;
case 245:
#line 1274 "gram.y"
{ yyval.expr = NewExprConst(BINARY_NUM, yyvsp[0].value); }
break;
case 246:
#line 1276 "gram.y"
{ yyval.expr = NewExprConst(HEX_NUM, yyvsp[0].value); }
break;
case 247:
#line 1278 "gram.y"
{ yyval.expr = NewExprConst(TEN_FLOAT, yyvsp[0].value); }
break;
case 248:
#line 1280 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_FLOAT, yyvsp[0].value); }
break;
case 249:
#line 1282 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yyvsp[0].value); }
break;
case 250:
#line 1284 "gram.y"
{ yyval.expr = NewExprConst(BINARY_FLOAT, yyvsp[0].value); }
break;
case 251:
#line 1286 "gram.y"
{ yyval.expr = NewExprConst(HEX_FLOAT, yyvsp[0].value); }
break;
case 252:
#line 1288 "gram.y"
{ yyval.expr = NewExprConst(CHAR_CONST, yyvsp[0].value); }
break;
case 253:
#line 1290 "gram.y"
{ yyval.expr = NewExprConst(STRING_CONST, yyvsp[0].value); }
break;
case 254:
#line 1292 "gram.y"
{ yyval.expr = NewExprConst(VOIDVAL, yyvsp[0].value); }
break;
case 255:
#line 1294 "gram.y"
{ yyval.expr = NewExprConst(BOOLVAL, yyvsp[0].value); }
break;
case 256:
#line 1296 "gram.y"
{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 257:
#line 1300 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = yyvsp[-4].type;
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 258:
#line 1308 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr); 
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 259:
#line 1315 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr);
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 260:
#line 1322 "gram.y"
{
			yyvsp[-1].expr->base.type = NewTypeHash (typePoly, yyvsp[-5].type);
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 261:
#line 1329 "gram.y"
{
			ParseCanonType (yyvsp[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[0].atom, 0, False), 0); 
			yyval.expr->base.type = yyvsp[-2].type;
		    }
break;
case 262:
#line 1335 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); 
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 263:
#line 1341 "gram.y"
{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yyvsp[0].value)); }
break;
case 264:
#line 1343 "gram.y"
{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 265:
#line 1345 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 266:
#line 1347 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 267:
#line 1349 "gram.y"
{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yyvsp[-3].expr, (Expr *) 0), yyvsp[-1].expr); }
break;
case 268:
#line 1351 "gram.y"
{ yyval.expr = NewExprTree(OS, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 269:
#line 1353 "gram.y"
{ yyval.expr = NewExprTree (OP, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 270:
#line 1355 "gram.y"
{ yyval.expr = NewExprTree(DOT, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 271:
#line 1357 "gram.y"
{ yyval.expr = NewExprTree(ARROW, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 272:
#line 1359 "gram.y"
{ 
			ParseCanonType (yyvsp[-5].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yyvsp[-5].type, yyvsp[-2].argType, yyvsp[-1].expr), 0); 
		    }
break;
case 274:
#line 1366 "gram.y"
{ yyval.value = Zero; }
break;
case 281:
#line 1379 "gram.y"
{ yyval.expr = 0; }
break;
case 282:
#line 1381 "gram.y"
{ yyval.expr = 0; }
break;
case 283:
#line 1384 "gram.y"
{ 
			ExprPtr	elts = yyvsp[-3].expr ? ExprRehang (yyvsp[-3].expr, 0) : 0;
			if (yyvsp[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTS, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 284:
#line 1398 "gram.y"
{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yyvsp[-5].expr, yyvsp[-4].expr), yyvsp[-2].expr);
		    }
break;
case 285:
#line 1403 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 287:
#line 1407 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 289:
#line 1411 "gram.y"
{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yyvsp[0].atom);
			yyval.expr = NewExprAtom (yyvsp[0].atom, s, False); 
		    }
break;
case 290:
#line 1419 "gram.y"
{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 291:
#line 1428 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 292:
#line 1430 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 296:
#line 1441 "gram.y"
{ yyval.expr = 0; }
break;
case 297:
#line 1443 "gram.y"
{ yyval.expr = 0; }
break;
case 298:
#line 1446 "gram.y"
{
			ExprPtr elts = yyvsp[-2].expr ? ExprRehang (yyvsp[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 299:
#line 1452 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 300:
#line 1454 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 301:
#line 1457 "gram.y"
{ yyval.expr = NewExprTree (DARROW, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 304:
#line 1466 "gram.y"
{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yyvsp[-2].expr, 0), 0); }
break;
case 305:
#line 1469 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 306:
#line 1471 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 307:
#line 1474 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 308:
#line 1476 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 312:
#line 1483 "gram.y"
{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4030 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
